#define TRUE  1
#define FALSE 0

/* for WORLD.DAT */
struct world_info {
  char name[61];     /* name of game, copyright etc.. */
  int loc[1600];     /* loc is each screen - x1,y1 is 1, then goes right
			until 80 is reached, then starts at x1,y2 for 81.
			physical map # of the record. If # is 0 if there
			is no screen */
  long v[40];        /* used by `v */
  char s[10][81];    /* used by `s */
  long time;         /* year+month+day?.. not sure, seth can't remember */
  char show[1600];   /* players auto 'map', 1 if doesn't show up */
  char extra[396];   /* reserved */
};


/* used by plan_rec */
struct map_info {
  char fc;           /* foreground color of square */
  char bc;           /* background color of square */
  unsigned char c;   /* actual character */
  int t;             /* seth can't remember */
  char s;            /* what type so it knows if you can walk through it or
			not.. here is the list:

  Assuming: struct plan_rec map;
	    char ter[11];

  if(map.w[x][y].s == 0) strcpy(ter, "Unpassable");
  if(map.w[x][y].s == 1) strcpy(ter, "Grass");
  if(map.w[x][y].s == 2) strcpy(ter, "Rocky");
  if(map.w[x][y].s == 3) strcpy(ter, "Water");
  if(map.w[x][y].s == 4) strcpy(ter, "Ocean");
  if(map.w[x][y].s == 5) strcpy(ter, "Forest");    */
};


/* used by plan_rec */
struct special_struct {
  int move_place;        /* map to move to, 0 if not a warp */
  char dx, dy;           /* xy cords of hotspot, 0 if hotspot not used */
  char x, y;             /* xy cords of warp desination, 0 if not a warp */
  char refname[13];      /* label of .ref procedure to run, if not a warp */
  char reffile[13];      /* filename of .ref to run if not a warp */
  char extra[100];       /* reserved */
};


/* for MAP.DAT */
struct plan_rec {
  char name[31];                       /* name of screen */
  struct map_info w[80][20];           /* each block on screen */
  struct special_struct special[10];   /* the 10 hotspots */
  long battle_odds;                    /* odds of running the 'random .ref' */
  char batfile[13];                    /* ref file name */
  char batname[13];                    /* label of ref procedure */
  char safe;                           /* true if players cannot fight on
					  this screen */
  char extra[469];                     /* reserved */
};
